using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Text;
using System.Windows.Forms;


namespace PDim2Rigid {
    public partial class Form1 : Form {
        public static bool GravityEnabled = true;

        public static int calcMode = 0;

        private GDIBackBuffer back;

        private Random random = new Random();
        private int colorR, colorRVel;
        private int colorG, colorGVel;
        private int colorB, colorBVel;

        private RigidBodies bodies = new RigidBodies();

        private RigidBody pickedBody = null;
        private Dim2Vector pickedPoint;
        private Dim2Vector mousePoint;

        double tm5 = 0;
        int numFrame = -1;
        DateTime beginTime;

        private void ClearByBasicFrame1() {
            pickedBody = null;
            bodies.Clear();

            RigidBody body;
            Dim2Vector[] verts;

            verts = new Dim2Vector[4];
            verts[0] = new Dim2Vector(0, 0);
            verts[1] = new Dim2Vector(pictureBox1.ClientSize.Width, 0);
            verts[2] = new Dim2Vector(pictureBox1.ClientSize.Width, 40);
            verts[3] = new Dim2Vector(0, 40);
            body = new RigidBody(verts, 0);
            body.pos.x = pictureBox1.ClientSize.Width / 2.0F;
            body.pos.y = 0;
            bodies.Add(body);
            body = new RigidBody(verts, 0);
            body.pos.x = pictureBox1.ClientSize.Width / 2.0F;
            body.pos.y = pictureBox1.ClientSize.Height;
            bodies.Add(body);

            verts = new Dim2Vector[4];
            verts[0] = new Dim2Vector(0, 0);
            verts[1] = new Dim2Vector(40, 0);
            verts[2] = new Dim2Vector(120, 30+pictureBox1.ClientSize.Height);
            verts[3] = new Dim2Vector(0, pictureBox1.ClientSize.Height);
            body = new RigidBody(verts, 0);
            body.pos.x = 0;
            body.pos.y = pictureBox1.ClientSize.Height / 2.0F;
            bodies.Add(body);
            verts = new Dim2Vector[4];
            verts[0] = new Dim2Vector(0, 0);
            verts[1] = new Dim2Vector(40, 0);
            verts[2] = new Dim2Vector(40, pictureBox1.ClientSize.Height);
            verts[3] = new Dim2Vector(-80, 30 + pictureBox1.ClientSize.Height);
            body = new RigidBody(verts, 0);
            body.pos.x = pictureBox1.ClientSize.Width;
            body.pos.y = pictureBox1.ClientSize.Height / 2.0F;
            bodies.Add(body);
        }


        public Form1() {
            InitializeComponent();
            checkBox1.Checked = GravityEnabled;
        }

        private void timer1_Tick(object sender, EventArgs e) {

            if (numFrame < 0 || numFrame % 200 == 199) {
                numFrame = 0;
                beginTime = DateTime.Now;
            }
            else {
                numFrame += 1;
            }


            label1.Text = "Vel̊jȊO\n" + bodies.tm1.ToString()
                + "\nVel̊j\n" + bodies.tm2.ToString()  
                + "\nImpulse̊jȊO\n(s쐬܂)\n" + bodies.tm3.ToString()
                + "\nImpulse̊j\n" + bodies.tm4.ToString()
                + "\n`\n" + tm5.ToString()
                + "\nFps\n" + (numFrame 
                    / DateTime.Now.Subtract(beginTime).TotalMilliseconds * 1000).ToString();

            colorR += colorRVel;
            colorG += colorGVel;
            colorB += colorBVel;

            if (colorR > 65535) {
                colorR = 65535;
                colorRVel = -random.Next(100, 1000);
            }
            if (colorG > 65535) {
                colorG = 65535;
                colorGVel = -random.Next(100, 1000);
            }
            if (colorB > 65535) {
                colorB = 65535;
                colorBVel = -random.Next(100, 1000);
            }

            if (colorR < 10000) {
                colorR = 10000;
                colorRVel = random.Next(100, 1000);
            }
            if (colorG < 10000) {
                colorG = 10000;
                colorGVel = random.Next(100, 1000);
            }
            if (colorB < 10000) {
                colorB = 10000;
                colorBVel = random.Next(100, 1000);
            }

            bodies.move1();

            if (pickedBody != null) {
                Dim2Vector worldPickedPoint;
                worldPickedPoint = pickedBody.transformVec(pickedPoint);
                Dim2Vector forcePoint = worldPickedPoint - pickedBody.pos;
                Dim2Vector velRel = pickedBody.velR(forcePoint);                
                Dim2Vector f;
                f = 0.5f * (mousePoint - worldPickedPoint);
                f += -0.5f * velRel;
                f = f / pickedBody.rm;
                pickedBody.force += f;
                pickedBody.moment += forcePoint % f;
            }

            bodies.move2();

            DateTime tmbg = DateTime.Now;
            PaintTo(pictureBox1);
            tm5 += DateTime.Now.Subtract(tmbg).TotalMilliseconds;
          
        }

        private void Form1_Load(object sender, EventArgs e) {
            back = new GDIBackBuffer(GDIFunctions.GetDC(pictureBox1.Handle.ToInt32()),
                pictureBox1.Width, pictureBox1.Height);

            colorR = random.Next(10000, 65536);
            colorG = random.Next(10000, 65536);
            colorB = random.Next(10000, 65536);
            colorRVel = random.Next(100, 1000);
            colorGVel = random.Next(100, 1000);
            colorBVel = random.Next(100, 1000);

            button1_Click(button1, null);
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e) {

        }

        private void Form1_KeyUp(object sender, KeyEventArgs e) {

        }

        private void PaintTo(Control obj) {
            Color myColor = Color.FromArgb(255, colorR / 256, colorG / 256, colorB / 256);

            int dc2 = GDIFunctions.GetDC(obj.Handle.ToInt32());

            int dc = back.DCHandle;


            using (GDIBrush br = new GDIBrush(myColor)) {
                GDIFunctions.SelectObject(dc, br.Handle);
                Rectangle r = new Rectangle(0, 0, obj.Width, obj.Height);
                GDIFunctions.FillRect(dc, ref r, br.Handle);
            }

            //bodies.drawAsGroup(dc);
            bodies.draw(dc);

            if (pickedBody != null) {               
                using (GDIPen pen = new GDIPen(Color.Lime, 4)) {
                    GDIFunctions.SelectObject(dc, pen.Handle);

                    Dim2Vector worldPickedPoint;
                    worldPickedPoint = pickedBody.transformVec(pickedPoint);
                    Point pt1, pt2;
                    pt2 = new Point();
                    pt1 = mousePoint.ToPoint();
                    GDIFunctions.MoveToEx(dc, pt1.X, pt1.Y, ref pt2);
                    pt2 = worldPickedPoint.ToPoint();
                    GDIFunctions.LineTo(dc, pt2.X, pt2.Y); 
                }
            }

            GDIFunctions.BitBlt(dc2, 0, 0, pictureBox1.Width, pictureBox1.Height, dc, 0, 0, 0x00CC0020);

            GDIFunctions.ReleaseDC(obj.Handle.ToInt32(), dc2);
        }

        private void pictureBox1_Paint(object sender, PaintEventArgs e) {
            
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e) {
            GravityEnabled = ((CheckBox)sender).Checked;
        }

        private void button1_Click(object sender, EventArgs e) {

            ClearByBasicFrame1();            

            RigidBody body;
            Dim2Vector[] verts;

            verts = new Dim2Vector[4];
            verts[0] = new Dim2Vector(0.0F, 0.0F);
            verts[1] = new Dim2Vector(70.0F, 0.0F);
            verts[2] = new Dim2Vector(70.0F, 26);
            verts[3] = new Dim2Vector(0.0F, 26.0F);

            for (int i = 0; i < 120; i++) {
                body = new RigidBody(verts, 1.0F);
                body.pos = new Dim2Vector(41 + (i % 9) * 61, 41 + (i / 9) * 31);
                body.color = Color.FromArgb(random.Next(100, 256),
                        random.Next(100, 256), random.Next(100, 256));           
                bodies.Add(body);
            }
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e) {
            if (e.Button == MouseButtons.Left) {
                Dim2Vector point;
                point = new Dim2Vector(e.X, e.Y);
                pickedBody = bodies.Pick(point);
                if (pickedBody != null) {
                    pickedPoint = pickedBody.deTransformVec(point);
                }
            }
        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e) {
            mousePoint = new Dim2Vector(e.X, e.Y);
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e) {
            if (e.Button == MouseButtons.Left) {
                pickedBody = null;
            }
        }

        private void button2_Click(object sender, EventArgs e) {

            ClearByBasicFrame1();

            RigidBody body;
            Dim2Vector[] verts;

            verts = new Dim2Vector[4];
            verts[0] = new Dim2Vector(0.0F, 0.0F);
            verts[1] = new Dim2Vector(70.0F, 0.0F);
            verts[2] = new Dim2Vector(70.0F, 26);
            verts[3] = new Dim2Vector(0.0F, 26.0F);
            
            for (int i = 0; i < 5; i++) {
                body = new RigidBody(verts, 1.0F);
                body.pos = new Dim2Vector(41 + (i % 6) * 41, 41 + (i / 6) * 21);
                body.color = Color.Green;
                bodies.Add(body);
            }

            verts = new Dim2Vector[4];
            verts[0] = new Dim2Vector(0.0F, 0.0F);
            verts[1] = new Dim2Vector(240.0F, -26.0F);
            verts[2] = new Dim2Vector(240.0F, 26);
            verts[3] = new Dim2Vector(0.0F, 26.0F);

            body = new RigidBody(verts, 0);
            body.pos.x = 300;
            body.pos.y = 300;
            bodies.Add(body);            
        }

        private void button3_Click(object sender, EventArgs e) {

            ClearByBasicFrame1();

            RigidBody body;
            Dim2Vector[] verts;

            verts = new Dim2Vector[4];
            verts[0] = new Dim2Vector(0.0F, 0.0F);
            verts[1] = new Dim2Vector(70.0F, 0.0F);
            verts[2] = new Dim2Vector(70.0F, 26);
            verts[3] = new Dim2Vector(0.0F, 26.0F);

            for (int i = 0; i < 20; i++) {
                body = new RigidBody(verts, 1.0F);
                body.pos = new Dim2Vector(41 + (i % 6) * 41, 41 + (i / 6) * 21);
                body.color = Color.Green;
                bodies.Add(body);
            }

            verts = new Dim2Vector[4];
            verts[0] = new Dim2Vector(0.0F, 0.0F);
            verts[1] = new Dim2Vector(240.0F, -26.0F);
            verts[2] = new Dim2Vector(240.0F, 26);
            verts[3] = new Dim2Vector(0.0F, 26.0F);

            body = new RigidBody(verts, 0);
            body.pos.x = 300;
            body.pos.y = 300;
            bodies.Add(body);            
        }

        private void fricTrackBar_Scroll(object sender, EventArgs e) {
            bodies.FricConst = fricTrackBar.Value * 0.1f;
            fricLabel.Text = "CW : " + (bodies.FricConst).ToString();
        }

        private void button4_Click(object sender, EventArgs e) {

            ClearByBasicFrame1();
          
            Dim2Vector[] verts;
            RigidBody[] tempBodies = new RigidBody[2];
            JointData jd;

            verts = new Dim2Vector[4];
            verts[0] = new Dim2Vector(0.0F, 0.0F);
            verts[1] = new Dim2Vector(70.0F, 0.0F);
            verts[2] = new Dim2Vector(70.0F, 26);
            verts[3] = new Dim2Vector(0.0F, 26.0F);

            for (int j = 0; j < 16; j++) {
                for (int i = 0; i < tempBodies.Length; i++) {
                    tempBodies[i] = new RigidBody(verts, 1.0F);
                    tempBodies[i].pos = new Dim2Vector(100 + i * 41, 41 + j * 30);
                    tempBodies[i].color = Color.Green;
                    bodies.Add(tempBodies[i]);
                }

                for (int i = 0; i < tempBodies.Length-1; i++) {
                    jd = new JointData();
                    jd.rb1 = tempBodies[i];
                    jd.rb2 = tempBodies[i+1];
                    jd.r1 = new Dim2Vector(40, 0);
                    jd.r2 = new Dim2Vector(-40, 0);
                    bodies.AddJoint(jd);
                }
            }
            
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e) {
            timer1.Enabled = checkBox2.Checked;
            if (checkBox2.Checked) {
                checkBox2.Text = "~";
            }
            else {
                checkBox2.Text = "Jn";
            }
        }

        private void pictureBox1_Resize(object sender, EventArgs e) {
            back = new GDIBackBuffer(GDIFunctions.GetDC(pictureBox1.Handle.ToInt32()),
                pictureBox1.Width, pictureBox1.Height);
        }

        private void button5_Click(object sender, EventArgs e) {
            ClearByBasicFrame1();

            Dim2Vector[] verts;
            RigidBody[] tempBodies = new RigidBody[10];
            JointData jd;

            verts = new Dim2Vector[4];
            verts[0] = new Dim2Vector(0.0F, 0.0F);
            verts[1] = new Dim2Vector(70.0F, 0.0F);
            verts[2] = new Dim2Vector(70.0F, 26);
            verts[3] = new Dim2Vector(0.0F, 26.0F);

            for (int j = 0; j < 2; j++) {
                for (int i = 0; i < tempBodies.Length; i++) {
                    tempBodies[i] = new RigidBody(verts, 1.0F);
                    tempBodies[i].pos = new Dim2Vector(100 + i * 30, 41 + j * 40);
                    tempBodies[i].color = Color.Green;
                    bodies.Add(tempBodies[i]);
                }

                for (int i = 0; i < tempBodies.Length-1; i++) {
                    jd = new JointData();
                    jd.rb1 = tempBodies[i];
                    jd.rb2 = tempBodies[i+1];
                    jd.r1 = new Dim2Vector(30, 0);
                    jd.r2 = new Dim2Vector(-30, 0);
                    jd.doHitTest = false;
                    bodies.AddJoint(jd);
                }
            }
        }

        private void button6_Click(object sender, EventArgs e) {
            ClearByBasicFrame1();

            Dim2Vector[] verts;
            RigidBody[] tempBodies = new RigidBody[10];
            JointData jd;
            MoterData mt;
            float pi = 3.14159265358979F;

            verts = new Dim2Vector[8];
            for (int i = 0; i < verts.Length; i++) {
                verts[i] = new Dim2Vector(
                    (float)(25*Math.Cos(2*pi*i/verts.Length)), 
                    (float)(25*Math.Sin(2*pi*i/verts.Length)));                        
            }
            tempBodies[0] = new RigidBody(verts, 1.0F);
            tempBodies[0].pos = new Dim2Vector(120, 40);
            tempBodies[0].color = Color.Green;
            bodies.Add(tempBodies[0]);
            tempBodies[1] = new RigidBody(verts, 1.0F);
            tempBodies[1].pos = new Dim2Vector(200, 40);
            tempBodies[1].color = Color.Green;
            bodies.Add(tempBodies[1]);

            verts = new Dim2Vector[4];
            verts[0] = new Dim2Vector(0.0F, 0.0F);
            verts[1] = new Dim2Vector(80.0F, 0.0F);
            verts[2] = new Dim2Vector(80.0F, 20.0F);
            verts[3] = new Dim2Vector(0.0F, 20.0F);
            tempBodies[2] = new RigidBody(verts, 4.0F);
            tempBodies[2].pos = new Dim2Vector(160, 40);
            tempBodies[2].color = Color.Green;
            bodies.Add(tempBodies[2]);

            jd = new JointData();
            jd.rb1 = tempBodies[2];
            jd.rb2 = tempBodies[0];
            jd.r1 = new Dim2Vector(-40, 0);
            jd.r2 = new Dim2Vector(0, 0);
            jd.doHitTest = false;
            bodies.AddJoint(jd);
            jd = new JointData();
            jd.rb1 = tempBodies[2];
            jd.rb2 = tempBodies[1];
            jd.r1 = new Dim2Vector(40, 0);
            jd.r2 = new Dim2Vector(0, 0);
            jd.doHitTest = false;
            bodies.AddJoint(jd);

            mt = new MoterData();
            mt.rb1 = tempBodies[2];
            mt.rb2 = tempBodies[0];
            mt.moment = 200000;
            bodies.moters.Add(mt);
            mt = new MoterData();
            mt.rb1 = tempBodies[2];
            mt.rb2 = tempBodies[1];
            mt.moment = 200000;
            bodies.moters.Add(mt);

            verts = new Dim2Vector[4];
            verts[0] = new Dim2Vector(0.0F, -52.0F);
            verts[1] = new Dim2Vector(440.0F, -26.0F);
            verts[2] = new Dim2Vector(440.0F, 26);
            verts[3] = new Dim2Vector(0.0F, 26.0F);
            tempBodies[0] = new RigidBody(verts, 0);
            tempBodies[0].pos.x = 300;
            tempBodies[0].pos.y = 300;
            bodies.Add(tempBodies[0]);    


            verts = new Dim2Vector[4];
            verts[0] = new Dim2Vector(0.0F, 0.0F);
            verts[1] = new Dim2Vector(70.0F, 0.0F);
            verts[2] = new Dim2Vector(70.0F, 26);
            verts[3] = new Dim2Vector(0.0F, 26.0F);

            for (int i = 0; i < 5; i++) {
                tempBodies[0] = new RigidBody(verts, 1.0F);
                tempBodies[0].pos = new Dim2Vector(41 + (i % 9) * 41, 41 + (i / 9) * 21);
                tempBodies[0].color = Color.FromArgb(random.Next(100, 256),
                        random.Next(100, 256), random.Next(100, 256));
                bodies.Add(tempBodies[0]);
            }
        }

        private void button7_Click(object sender, EventArgs e) {
            ClearByBasicFrame1();

            RigidBody body;
            Dim2Vector[] verts;

            for (int i = 0; i < 120; i++) {
                verts = new Dim2Vector[4];
                do {
                    verts[0] = new Dim2Vector(random.Next(-15, 15), random.Next(-15, 15));
                    verts[1] = new Dim2Vector(35+random.Next(-15, 15), random.Next(-15, 15));
                    verts[2] = new Dim2Vector(35+random.Next(-15, 15), 35+random.Next(-15, 15));
                    verts[3] = new Dim2Vector(random.Next(-15, 15), 35+random.Next(-15, 15));
                } while (Dim2Vector.isConvex(verts) == false);

                body = new RigidBody(verts, 1.0F);
                body.pos = new Dim2Vector(41 + (i % 9) * 41, 41 + (i / 9) * 21);
                body.color = Color.FromArgb(random.Next(100, 256),
                        random.Next(100, 256), random.Next(100, 256));
                bodies.Add(body);
            }
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e) {
            calcMode = int.Parse((String)((RadioButton)sender).Tag);
        }   
        


    }
}