
using System;
using System.Collections.Generic;

namespace PDim2Rigid {
    /// <summary>
    ///  Class ̊Tv̐
    /// </summary>
    public class ForceMatrixItem {

        public int r; //ԍ
        public float value; //l

    }

    public class ForceMatrixItemCol : List<ForceMatrixItem> {

        public void Resize(int a) {

            int i;

            for (i = Count; i < a; i++) {
                Add(null);
            }
            for (i = Count - 1; i >= a; i--) {
                RemoveAt(i);
            }
        }

        public float Sum(float[] x) {
            ForceMatrixItem item;
            float y = 0.0f;
            for (int i = Count - 1; i >= 0; i--) {
                item = this[i];
                y += item.value * x[item.r];
            }
            return y;
        }

    }

    public class ForceMatrixItemColList : List<ForceMatrixItemCol> {

        public void Resize(int a) {

            int i;

            for (i = Count; i < a; i++) {
                Add(null);
            }
            for (i = Count - 1; i >= a; i--) {
                RemoveAt(i);
            }
        }

    }

    public class ForceMatrix {


        ForceMatrixItemColList matData = new ForceMatrixItemColList();
        int colCount = 0;


        public void clear() {
            colCount = 0;
        }

        public void setSize(int col, int row) {

            colCount = col;
            if (matData.Count < col)
                matData.Resize(col);

            for (int i = col - 1; i >= 0; i--) {
                if (matData[i] == null) {
                    matData[i] = new ForceMatrixItemCol();
                }

                matData[i].Resize(row);

                ForceMatrixItemCol aaa = matData[i];
                for (int j = row - 1; j >= 0; j--) {
                    if (aaa[j] == null) {
                        aaa[j] = new ForceMatrixItem();
                    }
                }
            }
        }

        public void addRow(int i, ForceMatrixItem fmi) {
            matData[i].Add(fmi);
        }


        public ForceMatrixItem lastRow(int i) {
            return matData[i][matData[i].Count - 1];
        }


        public int col() {
            return colCount;
        }

        public int row(int i) {
            return matData[i].Count;
        }

        public ForceMatrixItemCol cols(int col) {
            return matData[col];
        }

        public ForceMatrixItem items(int col, int row) {
            return matData[col][row];
        }

    }

    public class MatrixMath {

        private static Random random = new Random();

        public static void solveSouhosei(ForceMatrix m, int[] indicies, float[] a, 
            float[] x, float[] c) {

            /*if (m.col() != a.Length && a.Length != x.Length) {
                System.Windows.Forms.MessageBox.Show("΂");
            }*/

            int middle;

            for (int i = 0; i < 2; i++) {
                middle = random.Next(indicies.Length);
                solveSouhoseiStep(m, indicies, a, x, 1.05F, 0.95F, c, middle, indicies.Length);
                solveSouhoseiStep(m, indicies, a, x, 1.05F, 0.95F, c, 0, middle);
            }
            for (int i = 0; i < 2; i++) {
                middle = random.Next(indicies.Length);
                solveSouhoseiStep(m, indicies, a, x, 1.00F, 1.00F, c, middle, indicies.Length);
                solveSouhoseiStep(m, indicies, a, x, 1.00F, 1.00F, c, 0, middle);
            }

        }

        private static void solveSouhoseiStep(ForceMatrix m, int[] indicies, float[] a,
                float[] x, float scale1, float scale2, float[] c, int bg, int ed) {
      
            int i, j;
            float y, q, imp, maxFric;
            ForceMatrixItemCol itemCol;

            for (j = bg; j < ed; j++) {

                i = indicies[j];

                itemCol = m.cols(2 * i);
                y = a[2 * i] + itemCol.Sum(x);

                if (c[2 * i] >= 0) {
                    if (y < 0) {

                        imp = -scale1 * y / itemCol[0].value;
                        x[2 * i] += imp;
                    }
                    else {
                        q = y - itemCol[0].value * x[2 * i];
                        if (q >= 0)
                            x[2 * i] = 0;
                        else
                            x[2 * i] -= scale2 * y / itemCol[0].value;

                    }

                    x[2 * i + 1] = 0.0f;

                    itemCol = m.cols(2 * i + 1);
                    q = a[2 * i + 1] + itemCol.Sum(x);                   

                    maxFric = Math.Abs(x[2 * i] * c[2* i + 1]);

                    q *= -1.0F / itemCol[0].value;

                    if (Math.Abs(q) > maxFric) {
                        if (q < 0) {
                            q = -maxFric;
                        }
                        else {
                            q = maxFric;
                        }
                    }

                    x[2 * i + 1] = q;
                }
                else {
                    imp = -scale1 * y / itemCol[0].value;
                    x[2 * i] += imp;

                    itemCol = m.cols(2 * i + 1);
                    y = a[2 * i + 1] + itemCol.Sum(x);       

                    imp = -scale1 * y / itemCol[0].value;
                    x[2 * i + 1] += imp;

                }

            }      

        }

        public static void solveImpulse(ForceMatrix m, float[] a, float[] x, float[] c) {

            /*if (m.col() != a.Length && a.Length != x.Length) {
                return;
            }*/

            int middle;

            for (int i = 0; i < 4; i++) {
                middle = random.Next(m.col()/2);
                solveImpulseStep(m, a, x, c, middle, m.col() / 2);
                solveImpulseStep(m, a, x, c, 0, middle);
            }

        }

        private static void solveImpulseStep(ForceMatrix m, float[] a,
                float[] x, float[] c, int bg, int ed) {

            int i;
            float y, imp, maxFric;
            ForceMatrixItemCol itemCol;

            for (i = bg; i < ed; i++) {
                itemCol = m.cols(2 * i);
                y = a[2 * i] + itemCol.Sum(x);

                if (c[2 * i] >= 0) {
                    if (y < 0) {
                        imp = -(1 + c[2 * i]) * y / itemCol[0].value;
                        x[2 * i] += imp;
                    }
                    else {
                        continue;
                    }

                    itemCol = m.cols(2 * i + 1);
                    y = a[2 * i + 1] + itemCol.Sum(x);                    

                    maxFric = Math.Abs(y * c[2 * i + 1] / itemCol[0].value);

                    if (y < 0) {
                        y = imp * c[2 * i + 1];
                    }
                    else {
                        y = -imp * c[2 * i + 1];
                    }

                    if (Math.Abs(y) > maxFric) {
                        if (y < 0) {
                            y = -maxFric;
                        }
                        else {
                            y = maxFric;
                        }
                    }

                    x[2 * i + 1] += y;
                }
                else {
                    imp = -(1 - c[2 * i]) * y / itemCol[0].value;
                    x[2 * i] += imp;

                    itemCol = m.cols(2 * i + 1);
                    y = a[2 * i + 1] + itemCol.Sum(x);

                    imp = -(1 - c[2 * i]) * y / itemCol[0].value;
                    x[2 * i + 1] += imp;
                }
            }        
            

        }

    }


}
